<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeperServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ZooKeeperServer.java</span></div><h1>ZooKeeperServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;

import javax.security.sasl.SaslException;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.Environment;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.KeeperException.Code;
import org.apache.zookeeper.KeeperException.SessionExpiredException;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Id;
import org.apache.zookeeper.data.StatPersisted;
import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.proto.AuthPacket;
import org.apache.zookeeper.proto.ConnectRequest;
import org.apache.zookeeper.proto.ConnectResponse;
import org.apache.zookeeper.proto.GetSASLRequest;
import org.apache.zookeeper.proto.ReplyHeader;
import org.apache.zookeeper.proto.RequestHeader;
import org.apache.zookeeper.proto.SetSASLResponse;
import org.apache.zookeeper.server.DataTree.ProcessTxnResult;
import org.apache.zookeeper.server.RequestProcessor.RequestProcessorException;
import org.apache.zookeeper.server.ServerCnxn.CloseRequestException;
import org.apache.zookeeper.server.SessionTracker.Session;
import org.apache.zookeeper.server.SessionTracker.SessionExpirer;
import org.apache.zookeeper.server.auth.AuthenticationProvider;
import org.apache.zookeeper.server.auth.ProviderRegistry;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.server.quorum.ReadOnlyZooKeeperServer;
import org.apache.zookeeper.txn.CreateSessionTxn;
import org.apache.zookeeper.txn.TxnHeader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


/**
 * This class implements a simple standalone ZooKeeperServer. It sets up the
 * following chain of RequestProcessors to process requests:
 * PrepRequestProcessor -&gt; SyncRequestProcessor -&gt; FinalRequestProcessor
 */
public class ZooKeeperServer implements SessionExpirer, ServerStats.Provider {
    protected static final Logger LOG;
    
    static {
<span class="fc" id="L81">        LOG = LoggerFactory.getLogger(ZooKeeperServer.class);</span>
        
<span class="fc" id="L83">        Environment.logEnv(&quot;Server environment:&quot;, LOG);</span>
    }

    protected ZooKeeperServerBean jmxServerBean;
    protected DataTreeBean jmxDataTreeBean;

 
    /**
     * The server delegates loading of the tree to an instance of the interface
     */
    public interface DataTreeBuilder {
        public DataTree build();
    }

<span class="fc" id="L97">    static public class BasicDataTreeBuilder implements DataTreeBuilder {</span>
        public DataTree build() {
<span class="nc" id="L99">            return new DataTree();</span>
        }
    }

    public static final int DEFAULT_TICK_TIME = 3000;
<span class="fc" id="L104">    protected int tickTime = DEFAULT_TICK_TIME;</span>
    /** value of -1 indicates unset, use default */
<span class="fc" id="L106">    protected int minSessionTimeout = -1;</span>
    /** value of -1 indicates unset, use default */
<span class="fc" id="L108">    protected int maxSessionTimeout = -1;</span>
    protected SessionTracker sessionTracker;
<span class="fc" id="L110">    private FileTxnSnapLog txnLogFactory = null;</span>
    private ZKDatabase zkDb;
<span class="fc" id="L112">    private final AtomicLong hzxid = new AtomicLong(0);</span>
<span class="fc" id="L113">    public final static Exception ok = new Exception(&quot;No prob&quot;);</span>
    protected RequestProcessor firstProcessor;
<span class="fc" id="L115">    protected volatile State state = State.INITIAL;</span>

<span class="pc" id="L117">    enum State {</span>
<span class="fc" id="L118">        INITIAL, RUNNING, SHUTDOWN;</span>
    }

    /**
     * This is the secret that we use to generate passwords, for the moment it
     * is more of a sanity check.
     */
    static final private long superSecret = 0XB3415C00L;

<span class="fc" id="L127">    private final AtomicInteger requestsInProcess = new AtomicInteger(0);</span>
<span class="fc" id="L128">    final List&lt;ChangeRecord&gt; outstandingChanges = new ArrayList&lt;ChangeRecord&gt;();</span>
    // this data structure must be accessed under the outstandingChanges lock
<span class="fc" id="L130">    final HashMap&lt;String, ChangeRecord&gt; outstandingChangesForPath =</span>
        new HashMap&lt;String, ChangeRecord&gt;();
    
    private ServerCnxnFactory serverCnxnFactory;

    private final ServerStats serverStats;

<span class="fc" id="L137">    private final ZooKeeperServerListener listener = new ZooKeeperServerListenerImpl();</span>

    void removeCnxn(ServerCnxn cnxn) {
<span class="fc" id="L140">        zkDb.removeCnxn(cnxn);</span>
<span class="fc" id="L141">    }</span>
 
    /**
     * Creates a ZooKeeperServer instance. Nothing is setup, use the setX
     * methods to prepare the instance (eg datadir, datalogdir, ticktime, 
     * builder, etc...)
     * 
     * @throws IOException
     */
<span class="fc" id="L150">    public ZooKeeperServer() {</span>
<span class="fc" id="L151">        serverStats = new ServerStats(this);</span>
<span class="fc" id="L152">    }</span>
    
    /**
     * Creates a ZooKeeperServer instance. It sets everything up, but doesn't
     * actually start listening for clients until run() is invoked.
     * 
     * @param dataDir the directory to put the data
     */
    public ZooKeeperServer(FileTxnSnapLog txnLogFactory, int tickTime,
            int minSessionTimeout, int maxSessionTimeout,
<span class="fc" id="L162">            DataTreeBuilder treeBuilder, ZKDatabase zkDb) {</span>
<span class="fc" id="L163">        serverStats = new ServerStats(this);</span>
<span class="fc" id="L164">        this.txnLogFactory = txnLogFactory;</span>
<span class="fc" id="L165">        this.zkDb = zkDb;</span>
<span class="fc" id="L166">        this.tickTime = tickTime;</span>
<span class="fc" id="L167">        this.minSessionTimeout = minSessionTimeout;</span>
<span class="fc" id="L168">        this.maxSessionTimeout = maxSessionTimeout;</span>
        
<span class="fc" id="L170">        LOG.info(&quot;Created server with tickTime &quot; + tickTime</span>
<span class="fc" id="L171">                + &quot; minSessionTimeout &quot; + getMinSessionTimeout()</span>
<span class="fc" id="L172">                + &quot; maxSessionTimeout &quot; + getMaxSessionTimeout()</span>
<span class="fc" id="L173">                + &quot; datadir &quot; + txnLogFactory.getDataDir()</span>
<span class="fc" id="L174">                + &quot; snapdir &quot; + txnLogFactory.getSnapDir());</span>
<span class="fc" id="L175">    }</span>

    /**
     * creates a zookeeperserver instance. 
     * @param txnLogFactory the file transaction snapshot logging class
     * @param tickTime the ticktime for the server
     * @param treeBuilder the datatree builder
     * @throws IOException
     */
    public ZooKeeperServer(FileTxnSnapLog txnLogFactory, int tickTime,
            DataTreeBuilder treeBuilder) throws IOException {
<span class="fc" id="L186">        this(txnLogFactory, tickTime, -1, -1, treeBuilder,</span>
                new ZKDatabase(txnLogFactory));
<span class="fc" id="L188">    }</span>
    
    public ServerStats serverStats() {
<span class="fc" id="L191">        return serverStats;</span>
    }

    public void dumpConf(PrintWriter pwriter) {
<span class="fc" id="L195">        pwriter.print(&quot;clientPort=&quot;);</span>
<span class="fc" id="L196">        pwriter.println(getClientPort());</span>
<span class="fc" id="L197">        pwriter.print(&quot;dataDir=&quot;);</span>
<span class="fc" id="L198">        pwriter.println(zkDb.snapLog.getSnapDir().getAbsolutePath());</span>
<span class="fc" id="L199">        pwriter.print(&quot;dataLogDir=&quot;);</span>
<span class="fc" id="L200">        pwriter.println(zkDb.snapLog.getDataDir().getAbsolutePath());</span>
<span class="fc" id="L201">        pwriter.print(&quot;tickTime=&quot;);</span>
<span class="fc" id="L202">        pwriter.println(getTickTime());</span>
<span class="fc" id="L203">        pwriter.print(&quot;maxClientCnxns=&quot;);</span>
<span class="fc" id="L204">        pwriter.println(serverCnxnFactory.getMaxClientCnxnsPerHost());</span>
<span class="fc" id="L205">        pwriter.print(&quot;minSessionTimeout=&quot;);</span>
<span class="fc" id="L206">        pwriter.println(getMinSessionTimeout());</span>
<span class="fc" id="L207">        pwriter.print(&quot;maxSessionTimeout=&quot;);</span>
<span class="fc" id="L208">        pwriter.println(getMaxSessionTimeout());</span>

<span class="fc" id="L210">        pwriter.print(&quot;serverId=&quot;);</span>
<span class="fc" id="L211">        pwriter.println(getServerId());</span>
<span class="fc" id="L212">    }</span>

    /**
     * This constructor is for backward compatibility with the existing unit
     * test code.
     * It defaults to FileLogProvider persistence provider.
     */
    public ZooKeeperServer(File snapDir, File logDir, int tickTime)
            throws IOException {
<span class="fc" id="L221">        this( new FileTxnSnapLog(snapDir, logDir),</span>
                tickTime, new BasicDataTreeBuilder());
<span class="fc" id="L223">    }</span>

    /**
     * Default constructor, relies on the config for its agrument values
     *
     * @throws IOException
     */
    public ZooKeeperServer(FileTxnSnapLog txnLogFactory,
            DataTreeBuilder treeBuilder)
        throws IOException
    {
<span class="nc" id="L234">        this(txnLogFactory, DEFAULT_TICK_TIME, -1, -1, treeBuilder,</span>
                new ZKDatabase(txnLogFactory));
<span class="nc" id="L236">    }</span>

    /**
     * get the zookeeper database for this server
     * @return the zookeeper database for this server
     */
    public ZKDatabase getZKDatabase() {
<span class="fc" id="L243">        return this.zkDb;</span>
    }
    
    /**
     * set the zkdatabase for this zookeeper server
     * @param zkDb
     */
    public void setZKDatabase(ZKDatabase zkDb) {
<span class="nc" id="L251">       this.zkDb = zkDb;</span>
<span class="nc" id="L252">    }</span>
    
    /**
     *  Restore sessions and data
     */
    public void loadData() throws IOException, InterruptedException {
        /*
         * When a new leader starts executing Leader#lead, it 
         * invokes this method. The database, however, has been
         * initialized before running leader election so that
         * the server could pick its zxid for its initial vote.
         * It does it by invoking QuorumPeer#getLastLoggedZxid.
         * Consequently, we don't need to initialize it once more
         * and avoid the penalty of loading it a second time. Not 
         * reloading it is particularly important for applications
         * that host a large database.
         * 
         * The following if block checks whether the database has
         * been initialized or not. Note that this method is
         * invoked by at least one other method: 
         * ZooKeeperServer#startdata.
         *  
         * See ZOOKEEPER-1642 for more detail.
         */
<span class="fc bfc" id="L276" title="All 2 branches covered.">        if(zkDb.isInitialized()){</span>
<span class="fc" id="L277">            setZxid(zkDb.getDataTreeLastProcessedZxid());</span>
        }
        else {
<span class="fc" id="L280">            setZxid(zkDb.loadDataBase());</span>
        }
        
        // Clean up dead sessions
<span class="fc" id="L284">        LinkedList&lt;Long&gt; deadSessions = new LinkedList&lt;Long&gt;();</span>
<span class="fc bfc" id="L285" title="All 2 branches covered.">        for (Long session : zkDb.getSessions()) {</span>
<span class="pc bpc" id="L286" title="1 of 2 branches missed.">            if (zkDb.getSessionWithTimeOuts().get(session) == null) {</span>
<span class="nc" id="L287">                deadSessions.add(session);</span>
            }
<span class="fc" id="L289">        }</span>
<span class="fc" id="L290">        zkDb.setDataTreeInit(true);</span>
<span class="pc bpc" id="L291" title="1 of 2 branches missed.">        for (long session : deadSessions) {</span>
            // XXX: Is lastProcessedZxid really the best thing to use?
<span class="nc" id="L293">            killSession(session, zkDb.getDataTreeLastProcessedZxid());</span>
<span class="nc" id="L294">        }</span>
<span class="fc" id="L295">    }</span>

    public void takeSnapshot(){

        try {
<span class="fc" id="L300">            txnLogFactory.save(zkDb.getDataTree(), zkDb.getSessionWithTimeOuts());</span>
<span class="nc" id="L301">        } catch (IOException e) {</span>
<span class="nc" id="L302">            LOG.error(&quot;Severe unrecoverable error, exiting&quot;, e);</span>
            // This is a severe error that we cannot recover from,
            // so we need to exit
<span class="nc" id="L305">            System.exit(10);</span>
<span class="fc" id="L306">        }</span>
<span class="fc" id="L307">    }</span>

  
    /**
     * This should be called from a synchronized block on this!
     */
    public long getZxid() {
<span class="fc" id="L314">        return hzxid.get();</span>
    }

    long getNextZxid() {
<span class="fc" id="L318">        return hzxid.incrementAndGet();</span>
    }

    public void setZxid(long zxid) {
<span class="fc" id="L322">        hzxid.set(zxid);</span>
<span class="fc" id="L323">    }</span>

    long getTime() {
<span class="fc" id="L326">        return System.currentTimeMillis();</span>
    }

    private void close(long sessionId) {
<span class="fc" id="L330">        submitRequest(null, sessionId, OpCode.closeSession, 0, null, null);</span>
<span class="fc" id="L331">    }</span>
    
    public void closeSession(long sessionId) {
<span class="nc" id="L334">        LOG.info(&quot;Closing session 0x&quot; + Long.toHexString(sessionId));</span>
        
        // we do not want to wait for a session close. send it as soon as we
        // detect it!
<span class="nc" id="L338">        close(sessionId);</span>
<span class="nc" id="L339">    }</span>

    protected void killSession(long sessionId, long zxid) {
<span class="nc" id="L342">        zkDb.killSession(sessionId, zxid);</span>
<span class="nc bnc" id="L343" title="All 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L344">            ZooTrace.logTraceMessage(LOG, ZooTrace.SESSION_TRACE_MASK,</span>
                                         &quot;ZooKeeperServer --- killSession: 0x&quot;
<span class="nc" id="L346">                    + Long.toHexString(sessionId));</span>
        }
<span class="nc bnc" id="L348" title="All 2 branches missed.">        if (sessionTracker != null) {</span>
<span class="nc" id="L349">            sessionTracker.removeSession(sessionId);</span>
        }
<span class="nc" id="L351">    }</span>

    public void expire(Session session) {
<span class="fc" id="L354">        long sessionId = session.getSessionId();</span>
<span class="fc" id="L355">        LOG.info(&quot;Expiring session 0x&quot; + Long.toHexString(sessionId)</span>
<span class="fc" id="L356">                + &quot;, timeout of &quot; + session.getTimeout() + &quot;ms exceeded&quot;);</span>
<span class="fc" id="L357">        close(sessionId);</span>
<span class="fc" id="L358">    }</span>

    public static class MissingSessionException extends IOException {
        private static final long serialVersionUID = 7467414635467261007L;

        public MissingSessionException(String msg) {
<span class="fc" id="L364">            super(msg);</span>
<span class="fc" id="L365">        }</span>
    }
    
    void touch(ServerCnxn cnxn) throws MissingSessionException {
<span class="fc bfc" id="L369" title="All 2 branches covered.">        if (cnxn == null) {</span>
<span class="fc" id="L370">            return;</span>
        }
<span class="fc" id="L372">        long id = cnxn.getSessionId();</span>
<span class="fc" id="L373">        int to = cnxn.getSessionTimeout();</span>
<span class="fc bfc" id="L374" title="All 2 branches covered.">        if (!sessionTracker.touchSession(id, to)) {</span>
<span class="fc" id="L375">            throw new MissingSessionException(</span>
<span class="fc" id="L376">                    &quot;No session with sessionid 0x&quot; + Long.toHexString(id)</span>
                    + &quot; exists, probably expired and removed&quot;);
        }
<span class="fc" id="L379">    }</span>

    protected void registerJMX() {
        // register with JMX
        try {
<span class="fc" id="L384">            jmxServerBean = new ZooKeeperServerBean(this);</span>
<span class="fc" id="L385">            MBeanRegistry.getInstance().register(jmxServerBean, null);</span>
            
            try {
<span class="fc" id="L388">                jmxDataTreeBean = new DataTreeBean(zkDb.getDataTree());</span>
<span class="fc" id="L389">                MBeanRegistry.getInstance().register(jmxDataTreeBean, jmxServerBean);</span>
<span class="nc" id="L390">            } catch (Exception e) {</span>
<span class="nc" id="L391">                LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L392">                jmxDataTreeBean = null;</span>
<span class="fc" id="L393">            }</span>
<span class="nc" id="L394">        } catch (Exception e) {</span>
<span class="nc" id="L395">            LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="nc" id="L396">            jmxServerBean = null;</span>
<span class="fc" id="L397">        }</span>
<span class="fc" id="L398">    }</span>
    
    public void startdata() 
    throws IOException, InterruptedException {
        //check to see if zkDb is not null
<span class="fc bfc" id="L403" title="All 2 branches covered.">        if (zkDb == null) {</span>
<span class="fc" id="L404">            zkDb = new ZKDatabase(this.txnLogFactory);</span>
        }  
<span class="pc bpc" id="L406" title="1 of 2 branches missed.">        if (!zkDb.isInitialized()) {</span>
<span class="fc" id="L407">            loadData();</span>
        }
<span class="fc" id="L409">    }</span>
    
    public synchronized void startup() {
<span class="fc bfc" id="L412" title="All 2 branches covered.">        if (sessionTracker == null) {</span>
<span class="fc" id="L413">            createSessionTracker();</span>
        }
<span class="fc" id="L415">        startSessionTracker();</span>
<span class="fc" id="L416">        setupRequestProcessors();</span>

<span class="fc" id="L418">        registerJMX();</span>

<span class="fc" id="L420">        state = State.RUNNING;</span>
<span class="fc" id="L421">        notifyAll();</span>
<span class="fc" id="L422">    }</span>

    protected void setupRequestProcessors() {
<span class="fc" id="L425">        RequestProcessor finalProcessor = new FinalRequestProcessor(this);</span>
<span class="fc" id="L426">        RequestProcessor syncProcessor = new SyncRequestProcessor(this,</span>
                finalProcessor);
<span class="fc" id="L428">        ((SyncRequestProcessor)syncProcessor).start();</span>
<span class="fc" id="L429">        firstProcessor = new PrepRequestProcessor(this, syncProcessor);</span>
<span class="fc" id="L430">        ((PrepRequestProcessor)firstProcessor).start();</span>
<span class="fc" id="L431">    }</span>

    public ZooKeeperServerListener getZooKeeperServerListener() {
<span class="fc" id="L434">        return listener;</span>
    }

    /**
     * Default listener implementation, which will do a graceful shutdown on
     * notification
     */
<span class="fc" id="L441">    private class ZooKeeperServerListenerImpl implements</span>
            ZooKeeperServerListener {

        @Override
        public void notifyStopping(String threadName, int exitCode) {
<span class="fc" id="L446">            LOG.info(&quot;Thread {} exits, error code {}&quot;, threadName, exitCode);</span>
<span class="fc" id="L447">            shutdown();</span>
<span class="fc" id="L448">        }</span>
    }

    protected void createSessionTracker() {
<span class="fc" id="L452">        sessionTracker = new SessionTrackerImpl(this, zkDb.getSessionWithTimeOuts(),</span>
<span class="fc" id="L453">                tickTime, 1, getZooKeeperServerListener());</span>
<span class="fc" id="L454">    }</span>
    
    protected void startSessionTracker() {
<span class="fc" id="L457">        ((SessionTrackerImpl)sessionTracker).start();</span>
<span class="fc" id="L458">    }</span>

    public boolean isRunning() {
<span class="fc bfc" id="L461" title="All 2 branches covered.">        return state == State.RUNNING;</span>
    }

    public synchronized void shutdown() {
<span class="fc bfc" id="L465" title="All 2 branches covered.">        if (!isRunning()) {</span>
<span class="fc" id="L466">            LOG.debug(&quot;ZooKeeper server is not running, so not proceeding to shutdown!&quot;);</span>
<span class="fc" id="L467">            return;</span>
        }
<span class="fc" id="L469">        LOG.info(&quot;shutting down&quot;);</span>

        // new RuntimeException(&quot;Calling shutdown&quot;).printStackTrace();
<span class="fc" id="L472">        state = State.SHUTDOWN;</span>
        // Since sessionTracker and syncThreads poll we just have to
        // set running to false and they will detect it during the poll
        // interval.
<span class="pc bpc" id="L476" title="1 of 2 branches missed.">        if (sessionTracker != null) {</span>
<span class="fc" id="L477">            sessionTracker.shutdown();</span>
        }
<span class="pc bpc" id="L479" title="1 of 2 branches missed.">        if (firstProcessor != null) {</span>
<span class="fc" id="L480">            firstProcessor.shutdown();</span>
        }
<span class="pc bpc" id="L482" title="1 of 2 branches missed.">        if (zkDb != null) {</span>
<span class="fc" id="L483">            zkDb.clear();</span>
        }

<span class="fc" id="L486">        unregisterJMX();</span>
<span class="fc" id="L487">    }</span>

    protected void unregisterJMX() {
        // unregister from JMX
        try {
<span class="pc bpc" id="L492" title="1 of 2 branches missed.">            if (jmxDataTreeBean != null) {</span>
<span class="fc" id="L493">                MBeanRegistry.getInstance().unregister(jmxDataTreeBean);</span>
            }
<span class="nc" id="L495">        } catch (Exception e) {</span>
<span class="nc" id="L496">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L497">        }</span>
        try {
<span class="pc bpc" id="L499" title="1 of 2 branches missed.">            if (jmxServerBean != null) {</span>
<span class="fc" id="L500">                MBeanRegistry.getInstance().unregister(jmxServerBean);</span>
            }
<span class="nc" id="L502">        } catch (Exception e) {</span>
<span class="nc" id="L503">            LOG.warn(&quot;Failed to unregister with JMX&quot;, e);</span>
<span class="fc" id="L504">        }</span>
<span class="fc" id="L505">        jmxServerBean = null;</span>
<span class="fc" id="L506">        jmxDataTreeBean = null;</span>
<span class="fc" id="L507">    }</span>

    public void incInProcess() {
<span class="fc" id="L510">        requestsInProcess.incrementAndGet();</span>
<span class="fc" id="L511">    }</span>

    public void decInProcess() {
<span class="fc" id="L514">        requestsInProcess.decrementAndGet();</span>
<span class="fc" id="L515">    }</span>

    public int getInProcess() {
<span class="fc" id="L518">        return requestsInProcess.get();</span>
    }

    /**
     * This structure is used to facilitate information sharing between PrepRP
     * and FinalRP.
     */
    static class ChangeRecord {
        ChangeRecord(long zxid, String path, StatPersisted stat, int childCount,
<span class="fc" id="L527">                List&lt;ACL&gt; acl) {</span>
<span class="fc" id="L528">            this.zxid = zxid;</span>
<span class="fc" id="L529">            this.path = path;</span>
<span class="fc" id="L530">            this.stat = stat;</span>
<span class="fc" id="L531">            this.childCount = childCount;</span>
<span class="fc" id="L532">            this.acl = acl;</span>
<span class="fc" id="L533">        }</span>

        long zxid;

        String path;

        StatPersisted stat; /* Make sure to create a new object when changing */

        int childCount;

        List&lt;ACL&gt; acl; /* Make sure to create a new object when changing */

        @SuppressWarnings(&quot;unchecked&quot;)
        ChangeRecord duplicate(long zxid) {
<span class="fc" id="L547">            StatPersisted stat = new StatPersisted();</span>
<span class="pc bpc" id="L548" title="1 of 2 branches missed.">            if (this.stat != null) {</span>
<span class="fc" id="L549">                DataTree.copyStatPersisted(this.stat, stat);</span>
            }
<span class="pc bpc" id="L551" title="1 of 2 branches missed.">            return new ChangeRecord(zxid, path, stat, childCount,</span>
                    acl == null ? new ArrayList&lt;ACL&gt;() : new ArrayList(acl));
        }
    }

    byte[] generatePasswd(long id) {
<span class="fc" id="L557">        Random r = new Random(id ^ superSecret);</span>
<span class="fc" id="L558">        byte p[] = new byte[16];</span>
<span class="fc" id="L559">        r.nextBytes(p);</span>
<span class="fc" id="L560">        return p;</span>
    }

    protected boolean checkPasswd(long sessionId, byte[] passwd) {
<span class="pc bpc" id="L564" title="1 of 2 branches missed.">        return sessionId != 0</span>
<span class="pc bpc" id="L565" title="1 of 2 branches missed.">                &amp;&amp; Arrays.equals(passwd, generatePasswd(sessionId));</span>
    }

    long createSession(ServerCnxn cnxn, byte passwd[], int timeout) {
<span class="fc" id="L569">        long sessionId = sessionTracker.createSession(timeout);</span>
<span class="fc" id="L570">        Random r = new Random(sessionId ^ superSecret);</span>
<span class="fc" id="L571">        r.nextBytes(passwd);</span>
<span class="fc" id="L572">        ByteBuffer to = ByteBuffer.allocate(4);</span>
<span class="fc" id="L573">        to.putInt(timeout);</span>
<span class="fc" id="L574">        cnxn.setSessionId(sessionId);</span>
<span class="fc" id="L575">        submitRequest(cnxn, sessionId, OpCode.createSession, 0, to, null);</span>
<span class="fc" id="L576">        return sessionId;</span>
    }

    /**
     * set the owner of this session as owner
     * @param id the session id
     * @param owner the owner of the session
     * @throws SessionExpiredException
     */
    public void setOwner(long id, Object owner) throws SessionExpiredException {
<span class="fc" id="L586">        sessionTracker.setOwner(id, owner);</span>
<span class="fc" id="L587">    }</span>

    protected void revalidateSession(ServerCnxn cnxn, long sessionId,
            int sessionTimeout) throws IOException {
<span class="fc" id="L591">        boolean rc = sessionTracker.touchSession(sessionId, sessionTimeout);</span>
<span class="pc bpc" id="L592" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L593">            ZooTrace.logTraceMessage(LOG,ZooTrace.SESSION_TRACE_MASK,</span>
<span class="nc" id="L594">                                     &quot;Session 0x&quot; + Long.toHexString(sessionId) +</span>
                    &quot; is valid: &quot; + rc);
        }
<span class="fc" id="L597">        finishSessionInit(cnxn, rc);</span>
<span class="fc" id="L598">    }</span>

    public void reopenSession(ServerCnxn cnxn, long sessionId, byte[] passwd,
            int sessionTimeout) throws IOException {
<span class="pc bpc" id="L602" title="1 of 2 branches missed.">        if (!checkPasswd(sessionId, passwd)) {</span>
<span class="nc" id="L603">            finishSessionInit(cnxn, false);</span>
        } else {
<span class="fc" id="L605">            revalidateSession(cnxn, sessionId, sessionTimeout);</span>
        }
<span class="fc" id="L607">    }</span>

    public void finishSessionInit(ServerCnxn cnxn, boolean valid) {
        // register with JMX
        try {
<span class="fc bfc" id="L612" title="All 2 branches covered.">            if (valid) {</span>
<span class="fc" id="L613">                serverCnxnFactory.registerConnection(cnxn);</span>
            }
<span class="nc" id="L615">        } catch (Exception e) {</span>
<span class="nc" id="L616">                LOG.warn(&quot;Failed to register with JMX&quot;, e);</span>
<span class="fc" id="L617">        }</span>

        try {
<span class="fc bfc" id="L620" title="All 4 branches covered.">            ConnectResponse rsp = new ConnectResponse(0, valid ? cnxn.getSessionTimeout()</span>
<span class="fc bfc" id="L621" title="All 2 branches covered.">                    : 0, valid ? cnxn.getSessionId() : 0, // send 0 if session is no</span>
                            // longer valid
<span class="fc" id="L623">                            valid ? generatePasswd(cnxn.getSessionId()) : new byte[16]);</span>
<span class="fc" id="L624">            ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L625">            BinaryOutputArchive bos = BinaryOutputArchive.getArchive(baos);</span>
<span class="fc" id="L626">            bos.writeInt(-1, &quot;len&quot;);</span>
<span class="fc" id="L627">            rsp.serialize(bos, &quot;connect&quot;);</span>
<span class="fc bfc" id="L628" title="All 2 branches covered.">            if (!cnxn.isOldClient) {</span>
<span class="fc" id="L629">                bos.writeBool(</span>
                        this instanceof ReadOnlyZooKeeperServer, &quot;readOnly&quot;);
            }
<span class="fc" id="L632">            baos.close();</span>
<span class="fc" id="L633">            ByteBuffer bb = ByteBuffer.wrap(baos.toByteArray());</span>
<span class="fc" id="L634">            bb.putInt(bb.remaining() - 4).rewind();</span>
<span class="fc" id="L635">            cnxn.sendBuffer(bb);    </span>

<span class="fc bfc" id="L637" title="All 2 branches covered.">            if (!valid) {</span>
<span class="fc" id="L638">                LOG.info(&quot;Invalid session 0x&quot;</span>
<span class="fc" id="L639">                        + Long.toHexString(cnxn.getSessionId())</span>
                        + &quot; for client &quot;
<span class="fc" id="L641">                        + cnxn.getRemoteSocketAddress()</span>
                        + &quot;, probably expired&quot;);
<span class="fc" id="L643">                cnxn.sendBuffer(ServerCnxnFactory.closeConn);</span>
            } else {
<span class="fc" id="L645">                LOG.info(&quot;Established session 0x&quot;</span>
<span class="fc" id="L646">                        + Long.toHexString(cnxn.getSessionId())</span>
<span class="fc" id="L647">                        + &quot; with negotiated timeout &quot; + cnxn.getSessionTimeout()</span>
                        + &quot; for client &quot;
<span class="fc" id="L649">                        + cnxn.getRemoteSocketAddress());</span>
<span class="fc" id="L650">                cnxn.enableRecv();</span>
            }
                
<span class="nc" id="L653">        } catch (Exception e) {</span>
<span class="nc" id="L654">            LOG.warn(&quot;Exception while establishing session, closing&quot;, e);</span>
<span class="nc" id="L655">            cnxn.close();</span>
<span class="fc" id="L656">        }</span>
<span class="fc" id="L657">    }</span>
    
    public void closeSession(ServerCnxn cnxn, RequestHeader requestHeader) {
<span class="nc" id="L660">        closeSession(cnxn.getSessionId());</span>
<span class="nc" id="L661">    }</span>

    public long getServerId() {
<span class="fc" id="L664">        return 0;</span>
    }

    /**
     * @param cnxn
     * @param sessionId
     * @param xid
     * @param bb
     */
    private void submitRequest(ServerCnxn cnxn, long sessionId, int type,
            int xid, ByteBuffer bb, List&lt;Id&gt; authInfo) {
<span class="fc" id="L675">        Request si = new Request(cnxn, sessionId, xid, type, bb, authInfo);</span>
<span class="fc" id="L676">        submitRequest(si);</span>
<span class="fc" id="L677">    }</span>
    
    public void submitRequest(Request si) {
<span class="pc bpc" id="L680" title="1 of 2 branches missed.">        if (firstProcessor == null) {</span>
<span class="nc" id="L681">            synchronized (this) {</span>
                try {
                    // Since all requests are passed to the request
                    // processor it should wait for setting up the request
                    // processor chain. The state will be updated to RUNNING
                    // after the setup.
<span class="nc bnc" id="L687" title="All 2 branches missed.">                    while (state == State.INITIAL) {</span>
<span class="nc" id="L688">                        wait(1000);</span>
                    }
<span class="nc" id="L690">                } catch (InterruptedException e) {</span>
<span class="nc" id="L691">                    LOG.warn(&quot;Unexpected interruption&quot;, e);</span>
<span class="nc" id="L692">                }</span>
<span class="nc bnc" id="L693" title="All 4 branches missed.">                if (firstProcessor == null || state != State.RUNNING) {</span>
<span class="nc" id="L694">                    throw new RuntimeException(&quot;Not started&quot;);</span>
                }
<span class="nc" id="L696">            }</span>
        }
        try {
<span class="fc" id="L699">            touch(si.cnxn);</span>
<span class="fc" id="L700">            boolean validpacket = Request.isValid(si.type);</span>
<span class="fc bfc" id="L701" title="All 2 branches covered.">            if (validpacket) {</span>
<span class="fc" id="L702">                firstProcessor.processRequest(si);</span>
<span class="fc bfc" id="L703" title="All 2 branches covered.">                if (si.cnxn != null) {</span>
<span class="fc" id="L704">                    incInProcess();</span>
                }
            } else {
<span class="fc" id="L707">                LOG.warn(&quot;Received packet at server of unknown type &quot; + si.type);</span>
<span class="fc" id="L708">                new UnimplementedRequestProcessor().processRequest(si);</span>
            }
<span class="fc" id="L710">        } catch (MissingSessionException e) {</span>
<span class="pc bpc" id="L711" title="1 of 2 branches missed.">            if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L712">                LOG.debug(&quot;Dropping request: &quot; + e.getMessage());</span>
            }
<span class="nc" id="L714">        } catch (RequestProcessorException e) {</span>
<span class="nc" id="L715">            LOG.error(&quot;Unable to process request:&quot; + e.getMessage(), e);</span>
<span class="fc" id="L716">        }</span>
<span class="fc" id="L717">    }</span>

    public static int getSnapCount() {
<span class="fc" id="L720">        String sc = System.getProperty(&quot;zookeeper.snapCount&quot;);</span>
        try {
<span class="fc" id="L722">            int snapCount = Integer.parseInt(sc);</span>

            // snapCount must be 2 or more. See org.apache.zookeeper.server.SyncRequestProcessor
<span class="fc bfc" id="L725" title="All 2 branches covered.">            if( snapCount &lt; 2 ) {</span>
<span class="fc" id="L726">                LOG.warn(&quot;SnapCount should be 2 or more. Now, snapCount is reset to 2&quot;);</span>
<span class="fc" id="L727">                snapCount = 2;</span>
            }
<span class="fc" id="L729">            return snapCount;</span>
<span class="fc" id="L730">        } catch (Exception e) {</span>
<span class="fc" id="L731">            return 100000;</span>
        }
    }

    public int getGlobalOutstandingLimit() {
<span class="fc" id="L736">        String sc = System.getProperty(&quot;zookeeper.globalOutstandingLimit&quot;);</span>
        int limit;
        try {
<span class="nc" id="L739">            limit = Integer.parseInt(sc);</span>
<span class="fc" id="L740">        } catch (Exception e) {</span>
<span class="fc" id="L741">            limit = 1000;</span>
<span class="nc" id="L742">        }</span>
<span class="fc" id="L743">        return limit;</span>
    }

    public void setServerCnxnFactory(ServerCnxnFactory factory) {
<span class="fc" id="L747">        serverCnxnFactory = factory;</span>
<span class="fc" id="L748">    }</span>

    public ServerCnxnFactory getServerCnxnFactory() {
<span class="fc" id="L751">        return serverCnxnFactory;</span>
    }

    /**
     * return the last proceesed id from the 
     * datatree
     */
    public long getLastProcessedZxid() {
<span class="fc" id="L759">        return zkDb.getDataTreeLastProcessedZxid();</span>
    }

    /**
     * return the outstanding requests
     * in the queue, which havent been 
     * processed yet
     */
    public long getOutstandingRequests() {
<span class="fc" id="L768">        return getInProcess();</span>
    }

    /**
     * trunccate the log to get in sync with others 
     * if in a quorum
     * @param zxid the zxid that it needs to get in sync
     * with others
     * @throws IOException
     */
    public void truncateLog(long zxid) throws IOException {
<span class="nc" id="L779">        this.zkDb.truncateLog(zxid);</span>
<span class="nc" id="L780">    }</span>
       
    public int getTickTime() {
<span class="fc" id="L783">        return tickTime;</span>
    }

    public void setTickTime(int tickTime) {
<span class="fc" id="L787">        LOG.info(&quot;tickTime set to &quot; + tickTime);</span>
<span class="fc" id="L788">        this.tickTime = tickTime;</span>
<span class="fc" id="L789">    }</span>

    public int getMinSessionTimeout() {
<span class="fc bfc" id="L792" title="All 2 branches covered.">        return minSessionTimeout == -1 ? tickTime * 2 : minSessionTimeout;</span>
    }

    public void setMinSessionTimeout(int min) {
<span class="fc" id="L796">        LOG.info(&quot;minSessionTimeout set to &quot; + min);</span>
<span class="fc" id="L797">        this.minSessionTimeout = min;</span>
<span class="fc" id="L798">    }</span>

    public int getMaxSessionTimeout() {
<span class="fc bfc" id="L801" title="All 2 branches covered.">        return maxSessionTimeout == -1 ? tickTime * 20 : maxSessionTimeout;</span>
    }

    public void setMaxSessionTimeout(int max) {
<span class="fc" id="L805">        LOG.info(&quot;maxSessionTimeout set to &quot; + max);</span>
<span class="fc" id="L806">        this.maxSessionTimeout = max;</span>
<span class="fc" id="L807">    }</span>

    public int getClientPort() {
<span class="fc bfc" id="L810" title="All 2 branches covered.">        return serverCnxnFactory != null ? serverCnxnFactory.getLocalPort() : -1;</span>
    }

    public void setTxnLogFactory(FileTxnSnapLog txnLog) {
<span class="fc" id="L814">        this.txnLogFactory = txnLog;</span>
<span class="fc" id="L815">    }</span>
    
    public FileTxnSnapLog getTxnLogFactory() {
<span class="fc" id="L818">        return this.txnLogFactory;</span>
    }

    public String getState() {
<span class="fc" id="L822">        return &quot;standalone&quot;;</span>
    }

    public void dumpEphemerals(PrintWriter pwriter) {
<span class="fc" id="L826">    	zkDb.dumpEphemerals(pwriter);</span>
<span class="fc" id="L827">    }</span>
    
    /**
     * return the total number of client connections that are alive
     * to this server
     */
    public int getNumAliveConnections() {
<span class="fc" id="L834">        return serverCnxnFactory.getNumAliveConnections();</span>
    }
    
    public void processConnectRequest(ServerCnxn cnxn, ByteBuffer incomingBuffer) throws IOException {
<span class="fc" id="L838">        BinaryInputArchive bia = BinaryInputArchive.getArchive(new ByteBufferInputStream(incomingBuffer));</span>
<span class="fc" id="L839">        ConnectRequest connReq = new ConnectRequest();</span>
<span class="fc" id="L840">        connReq.deserialize(bia, &quot;connect&quot;);</span>
<span class="pc bpc" id="L841" title="1 of 2 branches missed.">        if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L842">            LOG.debug(&quot;Session establishment request from client &quot;</span>
<span class="nc" id="L843">                    + cnxn.getRemoteSocketAddress()</span>
                    + &quot; client's lastZxid is 0x&quot;
<span class="nc" id="L845">                    + Long.toHexString(connReq.getLastZxidSeen()));</span>
        }
<span class="fc" id="L847">        boolean readOnly = false;</span>
        try {
<span class="fc" id="L849">            readOnly = bia.readBool(&quot;readOnly&quot;);</span>
<span class="fc" id="L850">            cnxn.isOldClient = false;</span>
<span class="fc" id="L851">        } catch (IOException e) {</span>
            // this is ok -- just a packet from an old client which
            // doesn't contain readOnly field
<span class="fc" id="L854">            LOG.warn(&quot;Connection request from old client &quot;</span>
<span class="fc" id="L855">                    + cnxn.getRemoteSocketAddress()</span>
                    + &quot;; will be dropped if server is in r-o mode&quot;);
<span class="fc" id="L857">        }</span>
<span class="pc bpc" id="L858" title="1 of 4 branches missed.">        if (readOnly == false &amp;&amp; this instanceof ReadOnlyZooKeeperServer) {</span>
<span class="nc" id="L859">            String msg = &quot;Refusing session request for not-read-only client &quot;</span>
<span class="nc" id="L860">                + cnxn.getRemoteSocketAddress();</span>
<span class="nc" id="L861">            LOG.info(msg);</span>
<span class="nc" id="L862">            throw new CloseRequestException(msg);</span>
        }
<span class="pc bpc" id="L864" title="1 of 2 branches missed.">        if (connReq.getLastZxidSeen() &gt; zkDb.dataTree.lastProcessedZxid) {</span>
<span class="nc" id="L865">            String msg = &quot;Refusing session request for client &quot;</span>
<span class="nc" id="L866">                + cnxn.getRemoteSocketAddress()</span>
                + &quot; as it has seen zxid 0x&quot;
<span class="nc" id="L868">                + Long.toHexString(connReq.getLastZxidSeen())</span>
                + &quot; our last zxid is 0x&quot;
<span class="nc" id="L870">                + Long.toHexString(getZKDatabase().getDataTreeLastProcessedZxid())</span>
                + &quot; client must try another server&quot;;

<span class="nc" id="L873">            LOG.info(msg);</span>
<span class="nc" id="L874">            throw new CloseRequestException(msg);</span>
        }
<span class="fc" id="L876">        int sessionTimeout = connReq.getTimeOut();</span>
<span class="fc" id="L877">        byte passwd[] = connReq.getPasswd();</span>
<span class="fc" id="L878">        int minSessionTimeout = getMinSessionTimeout();</span>
<span class="fc bfc" id="L879" title="All 2 branches covered.">        if (sessionTimeout &lt; minSessionTimeout) {</span>
<span class="fc" id="L880">            sessionTimeout = minSessionTimeout;</span>
        }
<span class="fc" id="L882">        int maxSessionTimeout = getMaxSessionTimeout();</span>
<span class="fc bfc" id="L883" title="All 2 branches covered.">        if (sessionTimeout &gt; maxSessionTimeout) {</span>
<span class="fc" id="L884">            sessionTimeout = maxSessionTimeout;</span>
        }
<span class="fc" id="L886">        cnxn.setSessionTimeout(sessionTimeout);</span>
        // We don't want to receive any packets until we are sure that the
        // session is setup
<span class="fc" id="L889">        cnxn.disableRecv();</span>
<span class="fc" id="L890">        long sessionId = connReq.getSessionId();</span>
<span class="fc bfc" id="L891" title="All 2 branches covered.">        if (sessionId != 0) {</span>
<span class="fc" id="L892">            long clientSessionId = connReq.getSessionId();</span>
<span class="fc" id="L893">            LOG.info(&quot;Client attempting to renew session 0x&quot;</span>
<span class="fc" id="L894">                    + Long.toHexString(clientSessionId)</span>
<span class="fc" id="L895">                    + &quot; at &quot; + cnxn.getRemoteSocketAddress());</span>
<span class="fc" id="L896">            serverCnxnFactory.closeSession(sessionId);</span>
<span class="fc" id="L897">            cnxn.setSessionId(sessionId);</span>
<span class="fc" id="L898">            reopenSession(cnxn, sessionId, passwd, sessionTimeout);</span>
<span class="fc" id="L899">        } else {</span>
<span class="fc" id="L900">            LOG.info(&quot;Client attempting to establish new session at &quot;</span>
<span class="fc" id="L901">                    + cnxn.getRemoteSocketAddress());</span>
<span class="fc" id="L902">            createSession(cnxn, passwd, sessionTimeout);</span>
        }
<span class="fc" id="L904">    }</span>

    public boolean shouldThrottle(long outStandingCount) {
<span class="fc bfc" id="L907" title="All 2 branches covered.">        if (getGlobalOutstandingLimit() &lt; getInProcess()) {</span>
<span class="fc bfc" id="L908" title="All 2 branches covered.">            return outStandingCount &gt; 0;</span>
        }
<span class="fc" id="L910">        return false; </span>
    }

    public void processPacket(ServerCnxn cnxn, ByteBuffer incomingBuffer) throws IOException {
        // We have the request, now process and setup for next
<span class="fc" id="L915">        InputStream bais = new ByteBufferInputStream(incomingBuffer);</span>
<span class="fc" id="L916">        BinaryInputArchive bia = BinaryInputArchive.getArchive(bais);</span>
<span class="fc" id="L917">        RequestHeader h = new RequestHeader();</span>
<span class="fc" id="L918">        h.deserialize(bia, &quot;header&quot;);</span>
        // Through the magic of byte buffers, txn will not be
        // pointing
        // to the start of the txn
<span class="fc" id="L922">        incomingBuffer = incomingBuffer.slice();</span>
<span class="fc bfc" id="L923" title="All 2 branches covered.">        if (h.getType() == OpCode.auth) {</span>
<span class="fc" id="L924">            LOG.info(&quot;got auth packet &quot; + cnxn.getRemoteSocketAddress());</span>
<span class="fc" id="L925">            AuthPacket authPacket = new AuthPacket();</span>
<span class="fc" id="L926">            ByteBufferInputStream.byteBuffer2Record(incomingBuffer, authPacket);</span>
<span class="fc" id="L927">            String scheme = authPacket.getScheme();</span>
<span class="fc" id="L928">            AuthenticationProvider ap = ProviderRegistry.getProvider(scheme);</span>
<span class="fc" id="L929">            Code authReturn = KeeperException.Code.AUTHFAILED;</span>
<span class="fc bfc" id="L930" title="All 2 branches covered.">            if(ap != null) {</span>
                try {
<span class="fc" id="L932">                    authReturn = ap.handleAuthentication(cnxn, authPacket.getAuth());</span>
<span class="nc" id="L933">                } catch(RuntimeException e) {</span>
<span class="nc" id="L934">                    LOG.warn(&quot;Caught runtime exception from AuthenticationProvider: &quot; + scheme + &quot; due to &quot; + e);</span>
<span class="nc" id="L935">                    authReturn = KeeperException.Code.AUTHFAILED;                   </span>
<span class="fc" id="L936">                }</span>
            }
<span class="fc bfc" id="L938" title="All 2 branches covered.">            if (authReturn!= KeeperException.Code.OK) {</span>
<span class="pc bpc" id="L939" title="1 of 2 branches missed.">                if (ap == null) {</span>
<span class="fc" id="L940">                    LOG.warn(&quot;No authentication provider for scheme: &quot;</span>
                            + scheme + &quot; has &quot;
<span class="fc" id="L942">                            + ProviderRegistry.listProviders());</span>
                } else {
<span class="nc" id="L944">                    LOG.warn(&quot;Authentication failed for scheme: &quot; + scheme);</span>
                }
                // send a response...
<span class="fc" id="L947">                ReplyHeader rh = new ReplyHeader(h.getXid(), 0,</span>
<span class="fc" id="L948">                        KeeperException.Code.AUTHFAILED.intValue());</span>
<span class="fc" id="L949">                cnxn.sendResponse(rh, null, null);</span>
                // ... and close connection
<span class="fc" id="L951">                cnxn.sendBuffer(ServerCnxnFactory.closeConn);</span>
<span class="fc" id="L952">                cnxn.disableRecv();</span>
<span class="fc" id="L953">            } else {</span>
<span class="pc bpc" id="L954" title="1 of 2 branches missed.">                if (LOG.isDebugEnabled()) {</span>
<span class="nc" id="L955">                    LOG.debug(&quot;Authentication succeeded for scheme: &quot;</span>
                              + scheme);
                }
<span class="fc" id="L958">                LOG.info(&quot;auth success &quot; + cnxn.getRemoteSocketAddress());</span>
<span class="fc" id="L959">                ReplyHeader rh = new ReplyHeader(h.getXid(), 0,</span>
<span class="fc" id="L960">                        KeeperException.Code.OK.intValue());</span>
<span class="fc" id="L961">                cnxn.sendResponse(rh, null, null);</span>
            }
<span class="fc" id="L963">            return;</span>
        } else {
<span class="fc bfc" id="L965" title="All 2 branches covered.">            if (h.getType() == OpCode.sasl) {</span>
<span class="fc" id="L966">                Record rsp = processSasl(incomingBuffer,cnxn);</span>
<span class="fc" id="L967">                ReplyHeader rh = new ReplyHeader(h.getXid(), 0, KeeperException.Code.OK.intValue());</span>
<span class="fc" id="L968">                cnxn.sendResponse(rh,rsp, &quot;response&quot;); // not sure about 3rd arg..what is it?</span>
<span class="fc" id="L969">            }</span>
            else {
<span class="fc" id="L971">                Request si = new Request(cnxn, cnxn.getSessionId(), h.getXid(),</span>
<span class="fc" id="L972">                  h.getType(), incomingBuffer, cnxn.getAuthInfo());</span>
<span class="fc" id="L973">                si.setOwner(ServerCnxn.me);</span>
<span class="fc" id="L974">                submitRequest(si);</span>
            }
        }
<span class="fc" id="L977">        cnxn.incrOutstandingRequests(h);</span>
<span class="fc" id="L978">    }</span>

    private Record processSasl(ByteBuffer incomingBuffer, ServerCnxn cnxn) throws IOException {
<span class="fc" id="L981">        LOG.debug(&quot;Responding to client SASL token.&quot;);</span>
<span class="fc" id="L982">        GetSASLRequest clientTokenRecord = new GetSASLRequest();</span>
<span class="fc" id="L983">        ByteBufferInputStream.byteBuffer2Record(incomingBuffer,clientTokenRecord);</span>
<span class="fc" id="L984">        byte[] clientToken = clientTokenRecord.getToken();</span>
<span class="fc" id="L985">        LOG.debug(&quot;Size of client SASL token: &quot; + clientToken.length);</span>
<span class="fc" id="L986">        byte[] responseToken = null;</span>
        try {
<span class="fc" id="L988">            ZooKeeperSaslServer saslServer  = cnxn.zooKeeperSaslServer;</span>
            try {
                // note that clientToken might be empty (clientToken.length == 0):
                // if using the DIGEST-MD5 mechanism, clientToken will be empty at the beginning of the
                // SASL negotiation process.
<span class="fc" id="L993">                responseToken = saslServer.evaluateResponse(clientToken);</span>
<span class="fc bfc" id="L994" title="All 2 branches covered.">                if (saslServer.isComplete() == true) {</span>
<span class="fc" id="L995">                    String authorizationID = saslServer.getAuthorizationID();</span>
<span class="fc" id="L996">                    LOG.info(&quot;adding SASL authorization for authorizationID: &quot; + authorizationID);</span>
<span class="fc" id="L997">                    cnxn.addAuthInfo(new Id(&quot;sasl&quot;,authorizationID));</span>
                }
            }
<span class="fc" id="L1000">            catch (SaslException e) {</span>
<span class="fc" id="L1001">                LOG.warn(&quot;Client failed to SASL authenticate: &quot; + e, e);</span>
<span class="fc bfc" id="L1002" title="All 2 branches covered.">                if ((System.getProperty(&quot;zookeeper.allowSaslFailedClients&quot;) != null)</span>
                  &amp;&amp;
<span class="pc bpc" id="L1004" title="1 of 2 branches missed.">                  (System.getProperty(&quot;zookeeper.allowSaslFailedClients&quot;).equals(&quot;true&quot;))) {</span>
<span class="fc" id="L1005">                    LOG.warn(&quot;Maintaining client connection despite SASL authentication failure.&quot;);</span>
                } else {
<span class="fc" id="L1007">                    LOG.warn(&quot;Closing client connection due to SASL authentication failure.&quot;);</span>
<span class="fc" id="L1008">                    cnxn.close();</span>
                }
<span class="fc" id="L1010">            }</span>
        }
<span class="nc" id="L1012">        catch (NullPointerException e) {</span>
<span class="nc" id="L1013">            LOG.error(&quot;cnxn.saslServer is null: cnxn object did not initialize its saslServer properly.&quot;);</span>
<span class="fc" id="L1014">        }</span>
<span class="fc bfc" id="L1015" title="All 2 branches covered.">        if (responseToken != null) {</span>
<span class="fc" id="L1016">            LOG.debug(&quot;Size of server SASL response: &quot; + responseToken.length);</span>
        }
        // wrap SASL response token to client inside a Response object.
<span class="fc" id="L1019">        return new SetSASLResponse(responseToken);</span>
    }
    
    public ProcessTxnResult processTxn(TxnHeader hdr, Record txn) {
        ProcessTxnResult rc;
<span class="fc" id="L1024">        int opCode = hdr.getType();</span>
<span class="fc" id="L1025">        long sessionId = hdr.getClientId();</span>
<span class="fc" id="L1026">        rc = getZKDatabase().processTxn(hdr, txn);</span>
<span class="fc bfc" id="L1027" title="All 2 branches covered.">        if (opCode == OpCode.createSession) {</span>
<span class="pc bpc" id="L1028" title="1 of 2 branches missed.">            if (txn instanceof CreateSessionTxn) {</span>
<span class="fc" id="L1029">                CreateSessionTxn cst = (CreateSessionTxn) txn;</span>
<span class="fc" id="L1030">                sessionTracker.addSession(sessionId, cst</span>
<span class="fc" id="L1031">                        .getTimeOut());</span>
<span class="fc" id="L1032">            } else {</span>
<span class="nc" id="L1033">                LOG.warn(&quot;*****&gt;&gt;&gt;&gt;&gt; Got &quot;</span>
<span class="nc" id="L1034">                        + txn.getClass() + &quot; &quot;</span>
<span class="nc" id="L1035">                        + txn.toString());</span>
            }
<span class="fc bfc" id="L1037" title="All 2 branches covered.">        } else if (opCode == OpCode.closeSession) {</span>
<span class="fc" id="L1038">            sessionTracker.removeSession(sessionId);</span>
        }
<span class="fc" id="L1040">        return rc;</span>
    }


}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>